package edu.umd.cs.voting.view;

import java.awt.BasicStroke;
import java.awt.Graphics2D;
import java.awt.geom.Line2D;

import edu.umd.cs.piccolo.PNode;
import edu.umd.cs.piccolo.util.PBounds;
import edu.umd.cs.piccolo.util.PPaintContext;

public class Checkbox extends PNode {
	
	protected static BasicStroke STROKE = new BasicStroke(1);
	protected static Line2D TEMP_LINE = new Line2D.Double();
	
	protected boolean isSelected = false;

	public Checkbox() {
		setPaint(CandidateNode.FOREGROUND);
	}

	public boolean getSelected() {
		return isSelected;
	}
	
	public void setSelected(boolean selected) {
		isSelected = selected;
		invalidatePaint();
	}

	protected void paint(PPaintContext paintContext) {
		Graphics2D g2 = paintContext.getGraphics();
		
		g2.setPaint(getParent().getPaint());
		g2.fill(getBoundsReference());
		
		g2.setPaint(getPaint());
		g2.draw(getBoundsReference());
		
		if (isSelected) {
			PBounds b = getBoundsReference();
			TEMP_LINE.setLine(b.x, b.y, b.x + b.width, b.y + b.height);
			g2.draw(TEMP_LINE);			
			TEMP_LINE.setLine(b.x + b.width, b.y, b.x, b.y + b.height);
			g2.draw(TEMP_LINE);
		}
	}
}
