package edu.umd.cs.voting.model;

import java.util.ArrayList;
import java.util.Iterator;

import org.jdom.Element;

public class Page {

	protected Ballot ballot;
	protected ArrayList title;
	protected String shortTitle;
	protected ArrayList instructions;
	protected ArrayList items;
	protected String submitButtonLabel;
	protected String semanticLabel;
	
	public Page(Ballot ballot, Element pageElement) {
		this.ballot = ballot;

		title = new ArrayList();
		instructions = new ArrayList();
		items = new ArrayList();

		Iterator i = null;

		semanticLabel = pageElement.getAttributeValue("semanticlabel");
		shortTitle = pageElement.getChild("title").getAttributeValue("shorttitle");
			
		i = pageElement.getChild("title").getChildren().iterator();
		while (i.hasNext()) {
			Element each = (Element) i.next();
			String text = each.getTextTrim();
			text = text.replaceAll("@br", "\n");
			if (text.length() > 0) title.add(text);
		}
		
		i = pageElement.getChild("instructions").getChildren().iterator();
		while (i.hasNext()) {
			Element each = (Element) i.next();
			String text = each.getTextTrim();
			text = text.replaceAll("@br", "\n");
			if (text.length() > 0) instructions.add(text);
		}

		i = pageElement.getChildren("item").iterator();
		while (i.hasNext()) {
			Element itemElement = (Element) i.next();
			Item item = new Item(this, itemElement);
			items.add(item);
		}
		
		Element submit = pageElement.getChild("submitbutton");
		if (submit != null) {
			submitButtonLabel = submit.getAttributeValue("label");
		}
	}
	
	public String getSemanticLabel() {
		return semanticLabel;
	}
	
	public String getShortTitle() {
		return shortTitle;
	}
	
	public ArrayList getTitle() {
		return title;
	}

	public ArrayList getInstructions() {
		return instructions;
	}
	
	public String getSubmitButtonLabel() {
		return submitButtonLabel;
	}
	
	public ArrayList getItems() {
		return items;
	}

	public void reset() {
		Iterator i = items.iterator();
		while (i.hasNext()) {
			Item each = (Item) i.next();
			each.reset();
		}
	}	
}
